var teste = false;
// teste = true;





var feiradorolo = {
	dir: ".feiradorolo",
	server : "http://agileti-feiradorolo.appspot.com",
	appLink : "http://agileti.net/app/feiradorolo",
	appLinkAndroid: "https://play.google.com/store/apps/details?id=agile.ti.mobile.feiradorolo",
	appLinkIos: "https://itunes.apple.com/br/app/agile.ti.mobile.feiradorolo/id877623596",
	appLinkWindowsPhone : "http://www.windowsphone.com/s?appid=1c00e78b-dba1-4222-b2bc-48cdd3e0cd20",
	qualificarApp : function() {
		if (device.platform.toLowerCase().indexOf("android") != -1) {
			openExternal(this.appLinkAndroid);
		}else if(device.platform.toLowerCase().indexOf("win") != -1){
			openExternal(this.appLinkWindowsPhone);
		}else {
			openExternal(this.appLinkIos);
		}
	},
	compartilharApp : function() {
		var text = "Confira o aplicativo Feira do Rolo de Conquista: " + "\n" + this.appLink;
		window.plugins.socialsharing.share(text);
	}
};





var classificados = {
	lista : new Array(),
	selectedIndex : -1,
	endOfList: false,
	page : 1,
	lastPage : 1,
	categoria : "",
	consulta : "",
	ordem: "",
	intervaloPublicidade : 10,
	limitePagina : 10,
	clear : function() {
		$('#contentPrincipal').html("");
		classificados.lista = new Array();
		classificados.page = 1;
		classificados.lastPage = 1;
		classificados.selectedIndex = -1;
		$('#divMaisResultados').hide();
	},
	loadAnuncios : function(callBackOk, callBackError) {
		
		if(classificados.imgLoading.auto){
			classificados.imgLoading.show();
		}else{
			utilidades.showLoading('Aguarde...');
		}
		
		var parametros = {
			"page" : classificados.page,
			"consulta" : classificados.consulta,
			"categoria" : classificados.categoria,
			"ordem" : classificados.getOrdem(),
			"conexao" : conexao.get(),
			"platform" : (!teste? device.platform : ""),
			"uuid" : (!teste? device.uuid : "")
		};

		$.ajaxSetup({
			cache : false
		});

		$.ajax({
			url : teste? 'json/lista.json' : feiradorolo.server+'/lista?time=' + (new Date()).getTime(),
			type : "POST", data : parametros, dataType : 'json',
			contentType : 'application/x-www-form-urlencoded; charset=ISO-8859-1',
			success : function(json) {
				
				var idxPub = 0;
				
				for (var i in json.list) {

					var iAux = classificados.lista.length;
					classificados.lista[iAux] = json.list[i];

					// if (i % classificados.intervaloPublicidade === 0) {
					// if (iAux == 0) {
						// var htmlPub = $('#templateAnuncioPublicidade').html();
						// htmlPub = templateReplace(htmlPub, "id", iAux);
						// $('#contentPrincipal').append(htmlPub);
					// }

					var html = $('#templateAnuncio').html();
					html = templateReplace(html, "id", iAux);
					html = templateReplace(html, "nome", json.list[i].nome);
					// html = templateReplace(html, "corFundo", json.list[i].cor);
					html = templateReplace(html, "categoria", json.list[i].categoria.nome);
					html = templateReplace(html, "valor", json.list[i].valor);
					$('#contentPrincipal').append(html);

					$('#img_' + iAux).attr("data-original", json.list[i].imagem.length > 0 ? json.list[i].imagem : "");
					
					// if (i % classificados.intervaloPublicidade === 0) {
					// if (iAux == 0) {
						// publicidade.set('pub_'+iAux, json.publicidade[idxPub].img, json.publicidade[idxPub].href);
						// idxPub++;
					// }

				}
				
				if(classificados.imgLoading.auto){
					classificados.imgLoading.hide();
				}else{
					utilidades.hideLoading();
				}
				
				if(classificados.consulta.length==0 && classificados.categoria.length==0){
					classificados.orderOff();
				}else{
					classificados.orderOn();
				}

				$("#contentPrincipal").listview("refresh");
				
				$('.imgListaAnuncio[src=""]').lazyload({
				    effect : "fadeIn",
				});

				if (json.list.length == 0 || json.list.length < classificados.limitePagina) {
					$('#divMaisResultados').hide();
					classificados.endOfList = true;
				} else {
					$('#divMaisResultados').show();
					classificados.endOfList = false;
				}
				
				$('#divTenteNovamente').hide();

				if (callBackOk != null) {
					setTimeout(callBackOk, 0);
				}
				
				if(classificados.page==1){
					
                	if(classificados.lista.length>=1){
                		pesquisa.updateHistorico();
                	}
                }
				
			},
			error : function(jqXHR, textStatus, errorThrown) {
				if(classificados.imgLoading.auto){
					classificados.imgLoading.hide();
				}else{
					utilidades.hideLoading();
				}
				classificados.page = classificados.lastPage;
				utilidades.msgError('Erro: ' + (jqXHR.status != 0 ? (jqXHR.status + ' - ' + errorThrown + '.') : "Sem conexão com a internet!"));
				
				if(classificados.lista.length === 0){
					$('#divTenteNovamente').show();
					$('#divMaisResultados').hide();
				}
				
				if (callBackError != null) {
					setTimeout(callBackError, 0);
				}
			}
		});
	},
	destaques: function(){
		classificados.consulta = "";
		$('#btnConsulta').hide();
		classificados.categoria = "";
		$('#btnCategoria').hide();
		classificados.clear();
		classificados.loadAnuncios();
	},
	maisResultados : function(auto) {
		classificados.imgLoading.auto = auto;
		classificados.lastPage = classificados.page;
		classificados.page += 1;
		classificados.loadAnuncios();
	},
	imgLoading: {
		auto: false,
		show: function(){
			$('#divMaisResultados').hide();
			$('#imgLoading').show();
		},
		hide: function(){
			classificados.imgLoading.auto = false;
			$('#imgLoading').hide();
			$('#divMaisResultados').show();
		}
	},
	abrirConsulta : function() {
		pesquisa.showPage();
	},
	cancelarConsulta : function() {
		classificados.consulta = "";
		$('#btnConsulta').hide();
		classificados.clear();
		classificados.orderOff();
		pesquisa.value = "";
		pesquisa.showPage();
	},
	consultar : function() {
		classificados.consulta = pesquisa.getValue();
		classificados.consulta = strReplaceAll(classificados.consulta, ' ', '+');
		$('#divConsulta').hide();
		$('#btnConsulta').html("Consulta: " + pesquisa.getValue());
		classificados.clear();
		if (classificados.consulta.length > 0) {
			classificados.categoria = "";
			$('#btnCategoria').hide();
			
			classificados.loadAnuncios(function() {
				$('#btnConsulta').show();
			});
		} else {
			$('#btnConsulta').hide();
			classificados.loadAnuncios();
		}
	},
	ordenar: function(){
		$( "#popupOrdenar" ).popup("open",{positionTo: "#btnConsultar"});
	},
	setOrdem: function(){
		classificados.ordem = $('#popupOrdenar input:checked').attr('value');
		$("#popupOrdenar").popup("close");
		classificados.clear();
		classificados.loadAnuncios();
	},
	getOrdem: function(){
		if(classificados.consulta.length==0 && classificados.categoria.length==0){
			return "";
		}else{
			return classificados.ordem;
		}
	},
	orderOn: function(){
		$('#btnConsultar').removeClass('ui-icon-search');
		$('#btnConsultar').addClass('ui-icon-arrow-d');
		$('#btnConsultar').attr("click","");
		$('#btnConsultar').unbind("click");
        $('#btnConsultar').bind("click", function(){
        	classificados.ordenar();
        });
	},
	orderOff: function(){
		$('#btnConsultar').removeClass('ui-icon-arrow-d');
		$('#btnConsultar').addClass('ui-icon-search');
		$('#btnConsultar').attr("click","");	
		$('#btnConsultar').unbind("click");
        $('#btnConsultar').bind("click", function(){
        	classificados.abrirConsulta();
        });	
	}
};





var scrollEvent = {
	timerScroll: null,
	delayScroll: 70,
	delay: 150,
	stopScroll: function(){
		if( $.mobile.activePage.is("#pagePrincipal") && !classificados.endOfList ){
			if( ( $(window).scrollTop() + $(window).height() ) >= ( $(document).height() - scrollEvent.delayScroll ) ) {
				classificados.maisResultados(true);
			}
		}
	},
	scroll: function(){
		try{ clearTimeout(scrollEvent.timerScroll); }
		catch(e){}
        scrollEvent.timerScroll = setTimeout( scrollEvent.stopScroll , scrollEvent.delay );
        
        if( $.mobile.activePage.is("#pagePrincipal") ){
	        if ($(window).scrollTop() > 300) {
				$('#divVoltarTopo').fadeIn();
			} else {
				$('#divVoltarTopo').fadeOut();
			}
		}
        
	},
	bind: function(){
		$(document).on("scrollstop", scrollEvent.scroll);
	}
};





var anuncios = {
	anuncio : null,
	showCount: 0,
	verAnuncio : function(index, transition) {
		if (classificados.selectedIndex != index) {
			utilidades.showLoading('Aguarde...');

			var parametros = {
				"codigo" : classificados.lista[index].codigo
			};

			$.ajaxSetup({
				cache : false
			});

			$.ajax({
				type : "POST",
				url : teste? 'json/anuncio.json' : feiradorolo.server + '/anuncio?time=' + (new Date()).getTime(),
				data : parametros,
				dataType : 'json',
				contentType : 'application/x-www-form-urlencoded; charset=ISO-8859-1',
				success : function(json) {
					classificados.selectedIndex = index;
					
					anuncios.anuncio = json.anuncio;

					$('#anuncioNome').html(classificados.lista[index].nome);
					$('#anuncioCategoria').html(classificados.lista[index].categoria.nome);
					$('#anuncioValor').html(classificados.lista[index].valor);
					$('#anuncioDescricao').html(json.anuncio.descricao);

					$('#anuncioContato').html(json.anuncio.contato);

					$('#anuncioContatos').html('');
					for (var i in json.anuncio.fones) {
						var html = $('#anuncioFoneTemplate').html();
						html = templateReplace(html, "fone", json.anuncio.fones[i]);
						$('#anuncioContatos').append(html);
					}
					
					if(json.anuncio.email.length>0){
						var html = $('#anuncioEmailTemplate').html();
						html = templateReplace(html, "email", json.anuncio.email);
						html = templateReplace(html, "subject", classificados.lista[index].nome);
						$('#anuncioContatos').append(html);
					}

					$('#anuncioDataCadastro').html(json.anuncio.dataCadastro);
					$('#anuncioViews').html('Visualizado: ' + json.anuncio.views);
					
					$('#anuncioDenuncia').attr('href', 'mailto:contato@feiradorolodeconquista.com.br?subject=Denúncia anúncio ' + classificados.lista[index].codigo );

					$('#divGallery').html('');
					var html = $('#templateGallery').html();
					$('#divGallery').html(html);

					countAnuncioImage = json.anuncio.imagens.length;
					indexAnuncioImage = 0;
					for (var i in json.anuncio.imagens) {
						var html = $('#templateGalleryItem').html();
						html = templateReplace(html, "index", i);
						html = templateReplace(html, "src", json.anuncio.imagens[i]);
						$('#ulGallery').append(html);
					}
					
					// publicidade.set('anuncioPub', json.anuncio.publicidade.img, json.anuncio.publicidade.href);
					
					utilidades.hideLoading();
					
					var fnSlide = function(){
						$('.flexslider').css("margin-bottom", (json.anuncio.imagens.length>1? "2em" : "0em") );
						$('.flexslider').flexslider({ animation : 'slide' });
					};
					
					if(transition){
						$.mobile.changePage('#pageVerAnuncio', { });
						setTimeout(fnSlide,200);
					}else{
						setTimeout(fnSlide,0);
					}
					
					anuncios.showCount++;
			        if(anuncios.showCount==2){
			        	avaliacao.testeDelay();
			        }
					
				},
				error : function(jqXHR, textStatus, errorThrown) {
					utilidades.hideLoading();
					utilidades.msgError('Erro: ' + (jqXHR.status != 0 ? (jqXHR.status + ' - ' + errorThrown + '.') : "Verifique a sua conexão!"));
				}
			});
		} else {
			$.mobile.changePage('#pageVerAnuncio', { });
		}
	},
	compartilhar : function() {
		var text = "Feira do Rolo de Conquista: " + "\n" + classificados.lista[classificados.selectedIndex].nome + "\n" + anuncios.anuncio.link;
		window.plugins.socialsharing.share(text);
	},
	openAnuncioImagem : function(index) {
		imgZoom.show(index);
	},
	anterior: function(){
		if(classificados.selectedIndex>0){
			anuncios.verAnuncio(parseInt(classificados.selectedIndex)-1, false);
		}else{
			utilidades.msgError('Início da lista!');
		}
	},
	proximo: function(){
		if(classificados.selectedIndex<(classificados.lista.length-1)){
			anuncios.verAnuncio(parseInt(classificados.selectedIndex)+1, false);
		}else{
			utilidades.msgError('Fim da lista!');
		}
	}
};





var imgZoom = {
	percentual: 100,
	show: function(index){
		
		$.mobile.changePage('#pageZoom', { });
		
		var urlImg = anuncios.anuncio.imagens[index];
		
		if( urlImg !== $('#imgZoom').attr('src') ){
			utilidades.showLoading('Aguarde...');
			$('#imgZoom').hide();
			
			$('#descricaoZoom').html(classificados.lista[classificados.selectedIndex].nome);
			
			imgZoom.percentual = 100;
			$('#imgZoom').attr('width', imgZoom.percentual+'%');
			
	        $('#imgZoom').load(function(){
				utilidades.hideLoading();
				$('#imgZoom').show();
				
				try{
					$('#imgZoom').panzoom("reset");
				}catch(exc){}
			});
	        $('#imgZoom').attr('src',urlImg);
		}
		
	},
	maisZoom: function(){
		imgZoom.percentual = imgZoom.percentual + 100;
		$('#imgZoom').attr('width', imgZoom.percentual+'%');
	},
	menosZoom: function(){
		imgZoom.percentual = imgZoom.percentual - 100;
		imgZoom.percentual = imgZoom.percentual>=100? imgZoom.percentual : 100;
		$('#imgZoom').attr('width', imgZoom.percentual+'%');
	}
};





var categorias = {
	lista : null,
	loadCategorias : function() {
		utilidades.showLoading('Aguarde...');

		$.ajaxSetup({ cache : false });

		$("#ulCategorias").html('');

		$.ajax({
			type : "POST",
			url : teste? 'json/categorias.json' : feiradorolo.server + '/categoria?time=' + (new Date()).getTime(),
			dataType : 'json',
			contentType : 'application/x-www-form-urlencoded; charset=ISO-8859-1',
			success : function(json) {

				categorias.lista = json.list;

				for (var i in json.list) {
					var html = json.list[i].sub ? $('#templateCategoriaSub').html() : $('#templateCategoria').html();
					html = templateReplace(html, "index", i);
					html = templateReplace(html, "nome", json.list[i].nome);
					$('#ulCategorias').append(html);
				}

				utilidades.hideLoading();

				$.mobile.changePage('#pageCategoria', { });

				$("#ulCategorias").listview("refresh");
				
			},
			error : function(jqXHR, textStatus, errorThrown) {
				utilidades.hideLoading();
				utilidades.msgError('Erro: ' + (jqXHR.status != 0 ? (jqXHR.status + ' - ' + errorThrown + '.') : "Verifique a sua conexão!"));
			}
		});
	},
	showCategoria : function(index) {
		classificados.clear();
		if (index >= 0) {
			classificados.categoria = categorias.lista[index].codigo;
			$('#btnCategoria').html("Categoria: "+categorias.lista[index].nome);
			$('#btnCategoria').show();
			
			classificados.consulta = "";
			$('#btnConsulta').hide();
			
			classificados.loadAnuncios(function() {
				back('pagePrincipal');
			});
		} else {
			classificados.categoria = "";
			$('#btnCategoria').hide();
			classificados.clear();
			classificados.orderOff();
			classificados.consultar();
		}
	}
}; 