$(function() {
	$.mobile.defaultPageTransition = 'slide';
});

function resize(start) {
	var width = $(window).width();
	var height = $(window).height();

	var portrait = height >= width;
	var big = ( portrait ? height : width) > 700;

	if (portrait) {
		if (big) {
			$('.imgPublicidade').css("min-width", "80%");
			$('.imgPublicidade').css("max-width", "100%");
		} else {
			$('.imgAgile').css("max-height", "30px");
			$('.imgPublicidade').css("min-width", "100%");
			$('.imgPublicidade').css("max-width", "100%");
		}
		$('.imgPublicidade').css("max-height", "80px");

		$('#divGallery').css("width", "inherit");
		$('#divGallery').css("margin-left", "");
	} else {
		$('.imgPublicidade').css("min-width", "60%");
		$('.imgPublicidade').css("max-width", "80%");
		if (big) {
			$('.imgPublicidade').css("max-height", "80px");
		} else {
			$('.imgPublicidade').css("max-height", "50px");
		}

		$('#divGallery').css("width", "70%");
		$('#divGallery').css("margin-left", "15%");
	}

	if (start) {
		if (big) {
			$('[data-mini=true]').removeClass('ui-mini');
			$('[data-mini=true]').attr("data-mini", "false");
			$('.imgGallery').css("min-height", "400px");
			$('.imgGallery').css("max-height", "400px");
			$(elmById('f1.4')).attr('checked', true).checkboxradio('refresh');
		} else {
			$(elmById('f1')).attr('checked', true).checkboxradio('refresh');
		}
		trocaFonte();
	}
}

function trocaFonte() {
	var tam = $('#font-selector input:checked').attr('value');
	$('.trocaFonte').css("font-size", tam + "em");

	tam = parseFloat(tam);
	mg = 2 - tam - 0.6;
	$('.trocaFonteMargin').css('margin-top', mg + 'em');
	$('.trocaFonteMargin').css('margin-bottom', mg + 'em');
}


$(document).on("pagecreate", function() {
	$("#font-selector input").on("change", function() {
		trocaFonte();
	});

	$("#popupOrdenar input").on("change", function(event, ui) {
		var newOrdem = $('#popupOrdenar input:checked').attr('value');
		if (newOrdem != classificados.ordem) {
			classificados.setOrdem();
		}
	});
});

$(function() {
	window.onresize = function() {
		resize(false);
	};
});

$(function() {
	app.initialize();
	classificados.orderOff();
});

$(function() {
	FastClick.attach(document.body);
});

// Correção do BUG do plugin LazyLoad: Ao mudar a PAGE, Abandonava as imagens ainda não carregadas
$(function() {
	$(document).on("pageshow", ".ui-page", function() {
		if (this.id === "pagePrincipal") {
			setTimeout(function() {
				$('.imgListaAnuncio[src=""]').lazyload({
					effect : "fadeIn",
				});
			}, 200);
		}
	});
});

function back(pageId){
	try{
		if (device.platform.toLowerCase().indexOf("ios") !== -1) {
	        $.mobile.changePage('#'+pageId, {reverse: true});
	    }else{
	        history.go(-1);
	    }
   	}catch(exc){
   		history.go(-1);
   	}
}

function openExternal(url) {
	window.open(url, '_system');
}