var pesquisa = {
	nameFile: '.historico',
	value: '',
	historico: null,
	showPage: function(){
		pesquisa.loadHistorico();
	},
	loadHistorico: function(){
		$('#ulSearch').html('');
		try{ $('#ulSearch').listview('refresh'); }
		catch(e){}
		
		utilidades.showLoading('Carregando...');
		
		if(pesquisa.historico == null){
			pesquisa.historico = new Array();
		}
		
		if(pesquisa.historico.length>0){
			var html = "";
			for(var i in pesquisa.historico) {
				html += "<li data-filtertext=\""+pesquisa.historico[i]+"\"><a href=\"javascript:pesquisa.change('"+pesquisa.historico[i]+"')\">"+pesquisa.historico[i]+"</a></li>";
			}
			$('#ulSearch').html(html);
			$('#divHistoricoVazio').hide();
		}else{
			$('#divHistoricoVazio').show();
		}
		
		try{ $('#ulSearch').listview('refresh'); }
        catch(e){}
        
        var functionPage = function(){
 			utilidades.hideLoading();
			$.mobile.changePage('#pageSearch', { transition: 'none' });
			
			$('#autocompleteSearch').unbind('keyup');
			$("#autocompleteSearch").keyup(function(event) {
		  		if (event.keyCode=='13'){
	  				pesquisa.change($('#autocompleteSearch').val());
		  		}
			});
		};
		
 		setTimeout(functionPage, 100);
		
	},
	change: function(text){
		pesquisa.value = text;
		
		back('pagePrincipal');
		
		setTimeout(
			function(){ classificados.consultar(); },
			100
		);
		
	},
	getHistorico: function(){
		fileReader.read(
			feiradorolo.dir,pesquisa.nameFile,
        	function(text){
        		pesquisa.historico = new Array();

        		var tempArray = text.split('|');
        		for(var i in tempArray) {
        			if(tempArray[i].length>0) {
	        			pesquisa.historico[ pesquisa.historico.length ] = tempArray[i];
					}
        		}
        		 
    		},
        	function(error){
        		pesquisa.historico = new Array();
        	}
        );		
	},
	updateHistorico: function(){
		var tempArray = new Array();
		
		if(pesquisa.getValue().length>0){
			tempArray[0] = pesquisa.getValue();	
		}
		
		for(var i in pesquisa.historico) {
			if(tempArray.length<=20 && pesquisa.historico[i] != tempArray[0]){
				tempArray[ tempArray.length ] = pesquisa.historico[i]; 
			}
		}
		
		pesquisa.historico = tempArray;
		
		var conteudo = '';
		for(var i in pesquisa.historico) {
			if(pesquisa.historico[i].length>0){
				conteudo += conteudo.length>0? '|' : '';
				conteudo += pesquisa.historico[i];
			}
		}
		
		try{
    		fileWriter.write(feiradorolo.dir,pesquisa.nameFile,conteudo,function(evt){ },function(error){ });
    	}catch(e){}
	},
	apagarHistorico: function(){
		pesquisa.historico = new Array();
		pesquisa.loadHistorico();
		pesquisa.updateHistorico();
	},
	voltar: function(){
		back('pagePrincipal');
		if(classificados.lista.length==0){
			classificados.consulta = "";
			$('#btnConsulta').hide();
			classificados.clear();
			pesquisa.value = "";
			classificados.consultar();
		}
	},
	getValue: function(){
		return pesquisa.value!=null? pesquisa.value : '';
	}
};