function elmById(id){
    return document.getElementById(id);
}

function clearSelect(id){
    var listOptions = elmById(id);
    try{
        while(listOptions.firstChild){
            listOptions.removeChild(listOptions.firstChild);
        }
    }catch(e){ }
}

function addToSelect(id, value, option, selected){
    var opt = document.createElement("option");
    opt.setAttribute("value", value);
    opt.appendChild(document.createTextNode(option));
    if(selected){
    	opt.setAttribute("selected", true);
    }
    elmById(id).appendChild(opt) ;
}

function getNumerais(txt){
	return limpador(txt, '0123456789');
}

function limpador(valor, validos) {
    var result = "";
    for (var i=0; i < valor.length; i++) {
        if(validos.indexOf(valor.substring(i, i+1)) >= 0){
            result += valor.substring(i, i+1);
        }
    }
    return result;
}

function strReplaceAll(str,arg1,arg2){
    if(arg1!=arg2){
        while(str.indexOf(arg1) != -1){
            str = str.replace(arg1,arg2);
        }
    }
    return str;
}

if(!String.prototype.trim) {
    String.prototype.trim = function () {
        return this.replace(/^\s+|\s+$/g,'');
	};
}

function templateReplace(template, key, value) {
	return strReplaceAll(template, "${" + key + "}", value);
}